import fr from "flatpickr/dist/l10n/fr";
import moment from "moment";

export default {
    data(){
        return {
            from: '',
            to: '',
            daterange: null,
            selectedAnnee: null
        }
    },
    computed: {
        config(){
            //var current_month = 12 - new Date().getMonth();
            return   {
                locale: fr.fr,
                mode: "range",
                dateFormat: "Y-m-d",
                firstDayOfWeek: 1,
                defaultDate: (this.selectedAnnee != null)?[this.selectedAnnee +"-" +new Date().getMonth()+"-01", this.selectedAnnee +"-12-"+new Date().getDay()]:[new Date().getFullYear()+'-'+ new Date().getMonth()+"-01", new Date().getFullYear()+'-'+new Date().getFullYear()+'-'+ new Date().getMonth()+"-31"],
            }

        },
    },
    methods:{

        checkDate(type){
            console.log(type)
            if (type === 'day')
                return this.daterange === moment().format("YYYY-MM-DD") + ' au ' + moment().format("YYYY-MM-DD") || this.daterange === moment().format("YYYY-MM-DD")
            if (type === 'week')
                return this.daterange === moment().startOf('isoWeek').format("YYYY-MM-DD") + ' au ' + moment().endOf('isoWeek') .format("YYYY-MM-DD")
            if (type === 'month')
                return this.daterange ===moment().startOf('month') .format("YYYY-MM-DD") + ' au ' + moment().endOf('month'). format("YYYY-MM-DD")
            if (type === 'year')
                return this.daterange ===moment().startOf('year') .format("YYYY-MM-DD") + ' au ' + moment().endOf('year'). format("YYYY-MM-DD")

        },
        filterByDay() {
            this.daterange = moment().format("YYYY-MM-DD") + ' au ' + moment().format("YYYY-MM-DD");
            this.from = this.to = moment().format("YYYY-MM-DD")
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()

        },
        filterByYesterday() {
            this.daterange = moment().subtract(1, 'days').format("YYYY-MM-DD") + ' au ' + moment().subtract(1, 'days').format("YYYY-MM-DD");
            this.from = moment().subtract(1, 'days').format("YYYY-MM-DD")
            this.to = moment().subtract(1, 'days').format("YYYY-MM-DD")

            localStorage.setItem('daterange', JSON.stringify(this.daterange));
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()

        },
        filterByLastWeek() {
            this.daterange = moment().subtract(1, 'weeks').startOf('week').format("YYYY-MM-DD") + ' au ' + moment().subtract(1, 'weeks').endOf('week').format("YYYY-MM-DD");
            this.from = moment().subtract(1, 'weeks').startOf('week').format("YYYY-MM-DD")
            this.to = moment().subtract(1, 'weeks').endOf('week').format("YYYY-MM-DD");
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()


            //console.log(this.daterange)
        },
        filterByLastMonth() {
            this.daterange = moment().subtract(1, 'months').startOf('month').format("YYYY-MM-DD") + ' au ' + moment().subtract(1, 'months').endOf('month').format("YYYY-MM-DD");
            this.from = moment().subtract(1, 'months').startOf('month').format("YYYY-MM-DD")
            this.to = moment().subtract(1, 'months').endOf('month').format("YYYY-MM-DD")
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()


            //console.log(this.daterange)
        },
        filterByWeek() {

            this.daterange = moment().startOf('isoWeek').format("YYYY-MM-DD") + ' au ' + moment().endOf('isoWeek').format("YYYY-MM-DD");
            this.from = moment().startOf('isoWeek').format("YYYY-MM-DD")
            this.to = moment().endOf('isoWeek').format("YYYY-MM-DD")
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()



        },
        filterByMonth() {
            this.daterange = moment().startOf('month').format("YYYY-MM-DD") + ' au ' + moment().endOf('month').format("YYYY-MM-DD");
            this.from = moment().startOf('month').format("YYYY-MM-DD")
            this.to = moment().endOf('month').format("YYYY-MM-DD")
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()


        },
        filterByYear() {
            this.daterange = moment().startOf('year').format("YYYY-MM-DD") + ' au ' + moment().endOf('year').format("YYYY-MM-DD");
            this.from = moment().startOf('year').format("YYYY-MM-DD")
            this.to = moment().endOf('year').format("YYYY-MM-DD")
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);
            location.reload()


            // console.log(' au ' + moment().endOf('year').format("YYYY-MM-DD"))
        },
        checkFunctionExistence(functionName) {
            if (typeof this[functionName] === "function") {
               return true
            } else {
                return false
            }
        },
        onDateChange() {
            this.from = this.daterange.includes('au')?this.daterange.split('au')[0]:this.daterange;
            this.to = this.daterange.includes('au')?this.daterange.split('au')[1]:this.daterange;
            localStorage.setItem('daterange', this.daterange);
            this.$store.dispatch("setDaterange", this.daterange);

            // this.fillTable();
            location.reload()

        },

    },
    created() {
        this.selectedAnnee = this.$store.state.selectedAnnee;
        console.log("daterange: " +this.$store.state.daterange)
        if (this.$store.state.daterange != null){
            this.daterange = this.$store.state.daterange
        }else{
            this.daterange = moment().format("YYYY-MM-DD") + ' au ' + moment(). format("YYYY-MM-DD");
            localStorage.setItem('daterange', this.daterange)

        }


        this.from = this.daterange.includes('au')?this.daterange.split('au')[0]:this.daterange;
        this.to = this.daterange.includes('au')?this.daterange.split('au')[1]:this.daterange.split('au')[1];
    }
}