import Api from "@/helpers/api";

export default {
    components:{

    },
    data(){
        return{
            api: new Api(),
            widTypeRamification: [],
            fields:[],
            currentUser: null,
            typeRamifications:[],
            userRamifications: [],
            selectedRamification: null
        }
    },
    methods:{
        selectRamification(val){
            this.selectedRamification = val.id;
            //console.log(this.userRamifications)
            localStorage.setItem('selectedRamification', JSON.stringify(this.userRamifications.find(item => item.id === Number(val.id))));

            this.$store.dispatch("selectedRamification", this.userRamifications.find(item => item.id === Number(val.id)));

        },
        changeRamification(val){
            this.selectedRamification = val;
        },
        getTypeRamification(){

            this.userRamifications = []
            this.fields = []
            if(this.$store.state.selectedEtablissement != null){
                this.fields.push({colonne: "ent.id", operator: "eq", value: this.$store.state.selectedEtablissement.id, connector: "and"})
            }
            if (this.currentUser.type.nom === 'Super Admin'){
                this.api.get("/ramifications")
                    .then(response => {
                        response.data.map(item => {
                            this.userRamifications.push(item)
                        })
                    })


                this.api.listing("/type_ramifications", this.fields, "tram.ordre", "asc", 1000, 1 )
                    .then(response => {
                        this.typeRamifications = response.data;
                        this.typeRamifications.forEach(item => {
                            if (this.$store.state.selectedRamification != null){
                                if (item.id === this.$store.state.selectedRamification.type.id){
                                    this.widTypeRamification.push({id:item.id, ordre: item.ordre, type: item.nom,text: item.nom, value: this.$store.state.selectedRamification.id, selected: true })

                                }else{
                                    this.widTypeRamification.push({id:item.id, ordre: item.ordre, type: item.nom,text: item.nom, value: null })
                                }
                            }else{
                                this.widTypeRamification.push({id:item.id, ordre: item.ordre, type: item.nom,text: item.nom, value: null })

                            }
                        })
                    })
            }else{
                this.userRamifications = []
                this.fields.push({colonne: 'tram.enabled', operator: 'eq', value: 1, connector: "and"})

                this.currentUser.affectations.forEach(item => {
                    if (item.enabled === true){
                        if (item.ramification !== null)
                        {
                            this.fields.push({colonne: 'tram.ordre', operator: 'gte', value: item.ramification.type.ordre, connector: "and"})
                        }else{
                            this.fields.push({colonne: 'ent.id', operator: 'gte', value: item.entite.id, connector: "and"})

                        }
                    }


                })

                this.api.listing("/type_ramifications", this.fields, "tram.ordre", "asc", 1000, 1 )
                    .then(response => {
                        this.typeRamifications = response.data;
                        this.typeRamifications.forEach(item => {
                            this.widTypeRamification.push({id:item.id, ordre: item.ordre, type: item.nom,text: item.nom, value: null })

                        })
                    })

            }

        },
        async getUserRamification() {
            this.userRamifications = []
            this.fields = []
            let response = [];
            this.isLoading = true;
            if (this.currentUser.type.nom === 'Super Admin') {
                if (this.$store.state.selectedEtablissement == null) {
                    response = await this.api.get("/ramifications")
                    response.data.forEach(item => {
                        if (!this.userRamifications.some(ram => ram.id === item.id)) {
                            this.userRamifications.push(item)
                        }
                    })
                } else {
                    let fields = [{
                        colonne: "ent.id",
                        operator: "eq",
                        value: this.$store.state.selectedEtablissement.id,
                        connector: "and"
                    }]
                    response = await this.api.listing("/ramifications", fields, "tram.ordre", "desc", 100000, 1)
                    response.data.forEach(item => {
                        if (!this.userRamifications.some(ram => ram.id === item.id)) {
                            this.userRamifications.push(item)
                        }
                    })
                }
            } else {
                this.userRamifications = []
                this.fields.push({colonne: 'tram.enabled', operator: 'eq', value: 1, connector: "and"})
              //  let index = 0
                for (let affectation of this.currentUser.affectations) {

                    if (affectation.ramification !== null) {
                        if (affectation.ramification.enabled === true) {
                            response = await this.api.get("/ramifications/" + affectation.ramification.id + "/childs")
                            for (const item of response) {
                                if (!this.userRamifications.some(ram => ram.id === item.id)) {
                                    this.userRamifications.push(item)
                                }
                            }

                        }
                    }
                    if (affectation.entite != null){
                        var fields = []

                        if (this.$store.state.selectedEtablissement === null) {
                            fields.push({
                                colonne: "ent.id",
                                operator: "eq",
                                value: affectation.entite.id,
                                connector: "and"
                            })
                            response = await this.api.listing("/ramifications", fields, "ram.nom", "asc", 10000, 1)
                            response.data.forEach(item => {
                                if (!this.userRamifications.some(ram => ram.id === item.id)) {
                                    this.userRamifications.push(item)
                                }
                            })
                        }
                        if(this.$store.state.selectedEtablissement != null){
                            fields.push({
                                colonne: "ent.id",
                                operator: "eq",
                                value: this.$store.state.selectedEtablissement.id,
                                connector: "and"
                            })

                            response = await this.api.listing("/ramifications", fields, "ram.nom", "asc", 10000, 1)
                            response.data.forEach(item => {
                                if (!this.userRamifications.some(ram => ram.id === item.id)) {

                                    this.userRamifications.push(item)
                                }
                            })
                        }
                    }
               //     index++
                }
            }
            this.isLoading = false;

        }


    },
    created() {
        this.currentUser = this.$store.state.currentUser
        if (this.$store.state.selectedRamification != null)
        {
            this.selectedRamification = this.$store.state.selectedRamification.id
        }
    }
}
